
libname dataout 'G:\res\Data\PSID';
filename J88224 "G:\res\Data\PSID\J88224.txt" ;
libname final 'G:\res\Research\RiskPrefs\PSID_KSS\Analysis';  


data riskPSID_CH;
    ATTRIB
      ER30000  FORMAT=F1.   LABEL="RELEASE NUMBER"                          
      ER30001  FORMAT=F4.   LABEL="1968 INTERVIEW NUMBER"                   
      ER30002  FORMAT=F3.   LABEL="PERSON NUMBER                         68"
      ER32000  FORMAT=F1.   LABEL="SEX OF INDIVIDUAL"                       
      ER32003  FORMAT=F1.   LABEL="WTR ORIGINAL SAMPLE/BORN IN/MOVED IN"    
      ER32049  FORMAT=F1.   LABEL="LAST KNOWN MARITAL STATUS"               
      ER7002   FORMAT=F4.   LABEL="1996 INTERVIEW #"                        
      ER7003   FORMAT=F4.   LABEL="INTERVIEWER ID"                          
      ER7004   FORMAT=F4.   LABEL="DATE OF INTERVIEW"                       
      ER7005   FORMAT=F2.   LABEL="# IN FU"                                 
      ER7006   FORMAT=F2.   LABEL="AGE OF HEAD"                             
      ER7007   FORMAT=F1.   LABEL="SEX OF HEAD"                             
      ER7008   FORMAT=F2.   LABEL="AGE OF WIFE"                             
      ER7009   FORMAT=F2.   LABEL="# CHILDREN IN FU"                        
      ER7012   FORMAT=F1.   LABEL="WHO WAS RESPONDENT"                      
      ER7014   FORMAT=F1.   LABEL="A4 TYPE DU"                              
      ER7031   FORMAT=F1.   LABEL="A19 OWN/RENT OR WHAT"                    
      ER7035   FORMAT=F1.   LABEL="A23 HAVE MORTGAGE?"                      
      ER7163   FORMAT=F1.   LABEL="B1 EMPLOYMENT STATUS-HD"                 
      ER7168   FORMAT=F1.   LABEL="B3 WORK FOR MONEY?(HD-E)"                
      ER7169   FORMAT=F1.   LABEL="B4 WORK SELF/OTR? (HD-E)"                
      ER7657   FORMAT=F1.   LABEL="D1A EMPLOYMENT STATUS-WF"                
      ER7662   FORMAT=F1.   LABEL="D3 WORK FOR MONEY?(WF-E)"                
      ER7663   FORMAT=F1.   LABEL="D4 WORK SELF/OTR? (WF-E)"                
      ER8969   FORMAT=F1.   LABEL="H1 STATUS OF HEALTH-HEAD"                
      ER8974   FORMAT=F1.   LABEL="H28 STATUS OF HLTH-WIFE"                 
      ER8980   FORMAT=F2.   LABEL="K2 EDUC OF FATHER WF"                    
      ER8982   FORMAT=F2.   LABEL="K4 EDUC OF MOTHER WF"                    
      ER8996   FORMAT=F1.   LABEL="K18 SPANISH DESCENT 1 WF"                
      ER8999   FORMAT=F1.   LABEL="K19 RACE OF WIFE      1"                 
      ER9057   FORMAT=F1.   LABEL="L31 SPANISH DESCENT 1 HD"                
      ER9060   FORMAT=F1.   LABEL="L32 RACE OF HEAD      1"                 
      ER9103   FORMAT=F1.   LABEL="M1 ONE THIRD INCOME CUT"                 
      ER9104   FORMAT=F1.   LABEL="M2 ONE HALF INCOME CUT"                  
      ER9105   FORMAT=F1.   LABEL="M3 20 PERCENT INCOME CUT"                
      ER9106   FORMAT=F1.   LABEL="M4 10 PERCENT INCOME CUT"                
      ER9107   FORMAT=F1.   LABEL="M5 75 PERCENT INCOME CUT"                
      ER9231   FORMAT=F7.   LABEL="LABOR INCOME OF HEAD-1995"               
      ER9235   FORMAT=F7.   LABEL="LABOR INCOME OF WIFE-1995"               
      ER9244   FORMAT=F7.   LABEL="TOTAL FAMILY INCOME-1995"                
      ER9247   FORMAT=F2.   LABEL="PSID STATE OF RESIDENCE CODE"            
      ER9248   FORMAT=F2.   LABEL="CURRENT STATE"                           
      ER9249   FORMAT=F2.   LABEL="COMPLETED ED-HD"                         
      ER9250   FORMAT=F2.   LABEL="COMPLETED ED-WF"                         
      ER9251   FORMAT=F7.3  LABEL="1996 FAMILY WEIGHT"                      
      RT       FORMAT=F5.3  LABEL="RISK TOLERANCE"                          
      RT1      FORMAT=F4.2  LABEL="RT96-RISK TOLERANCE 1"                   
      ER33301  FORMAT=F4.   LABEL="1996 INTERVIEW NUMBER"                   
      ER33302  FORMAT=F2.   LABEL="SEQUENCE NUMBER                       96"
      ER33303  FORMAT=F2.   LABEL="RELATION TO HEAD                      96"
      ER33304  FORMAT=F3.   LABEL="AGE OF INDIVIDUAL                     96"
      ER33307  FORMAT=F1.   LABEL="MARITAL PAIRS INDICATOR               96"
      ER33311  FORMAT=F1.   LABEL="EMPLOYMENT STATUS                     96"
      ER33315  FORMAT=F2.   LABEL="YEARS COMPLETED EDUCATION             96"
      ER33316  FORMAT=F1.   LABEL="HAS MEDICAL COVERAGE?                 96"
      ER33317  FORMAT=F1.   LABEL="HEALTH GOOD?                          96"
      ER33318  FORMAT=F7.3  LABEL="CORE INDIVIDUAL LONGITUDINAL WEIGHT   96"
      ER33326  FORMAT=F1.   LABEL="H1 HEALTH STATUS                      96"
   ;
   INFILE J88224 LRECL = 127 ; 
   INPUT 
      ER30000      1 - 1     ER30001      2 - 5     ER30002      6 - 8    
      ER32000      9 - 9     ER32003     10 - 10    ER32049     11 - 11   
      ER7002      12 - 15    ER7003      16 - 19    ER7004      20 - 23   
      ER7005      24 - 25    ER7006      26 - 27    ER7007      28 - 28   
      ER7008      29 - 30    ER7009      31 - 32    ER7012      33 - 33   
      ER7014      34 - 34    ER7031      35 - 35    ER7035      36 - 36   
      ER7163      37 - 37    ER7168      38 - 38    ER7169      39 - 39   
      ER7657      40 - 40    ER7662      41 - 41    ER7663      42 - 42   
      ER8969      43 - 43    ER8974      44 - 44    ER8980      45 - 46   
      ER8982      47 - 48    ER8996      49 - 49    ER8999      50 - 50   
      ER9057      51 - 51    ER9060      52 - 52    ER9103      53 - 53   
      ER9104      54 - 54    ER9105      55 - 55    ER9106      56 - 56   
      ER9107      57 - 57    ER9231      58 - 64    ER9235      65 - 71   
      ER9244      72 - 78    ER9247      79 - 80    ER9248      81 - 82   
      ER9249      83 - 84    ER9250      85 - 86    ER9251      87 - 93   
      RT          94 - 98    RT1         99 - 102   ER33301    103 - 106  
      ER33302    107 - 108   ER33303    109 - 110   ER33304    111 - 113  
      ER33307    114 - 114   ER33311    115 - 115   ER33315    116 - 117  
      ER33316    118 - 118   ER33317    119 - 119   ER33318    120 - 126  
      ER33326    127 - 127  
   ;

** 1996 family identifier;
id96 = ER33301;

** Gamble response categories;
if ER9103 = 5 and ER9105 = 5 and ER9106 = 5 then risk = 1;
	else if ER9103 = 5 and ER9105 = 5 and ER9106 = 1 then risk = 2;
	else if ER9103 = 5 and ER9105 = 1 then risk = 3;
	else if ER9103 = 1 and ER9104 = 5 then risk = 4;
	else if ER9103 = 1 and ER9104 = 1 and ER9107 = 5 then risk = 5;
	else if ER9103 = 1 and ER9104 = 1 and ER9107 = 1 then risk = 6;
	else if ER9103 in(8,9) or ER9104 in(8,9) or ER9105 in(8,9) or ER9106 in(8,9) then risk = 9;
	else risk = 0;

proc freq data = riskPSID_CH; tables ER7012; run;


proc sort nodupkey; by id96;

proc freq data = final.intergen_main; table risk prisk; run;

data sampleCH(keep = id96 p_id96);
	set final.intergen_main;

if retir_84 = 0 and age_99 <= 65 and age_99 >= 25 and 
dead = 0 and pageavg <= 65
and b_age ne . and pb_age ne . and pfaminc ne . and 
whi_99 < 9999997 and pwhiavg < 9999997 and whi_99 > 0 and pwhiavg > 0 and risk1 ne . and prisk1 ne .;;

proc sort data = sampleCH; by id96;
proc sort data = riskPSID_CH; by id96;

data sampleCH;
	merge sampleCH(in=inG) riskPSID_CH(rename=(risk=risk_CH ));
	by id96;
	if inG;

proc sort data = sampleCH; by p_id96;

data sampleCH;
	merge sampleCH(in=inG) riskPSID_CH(rename=(id96=p_id96 risk=prisk_CH ));
	by p_id96;
	if inG;

if 1 <= prisk_CH <= 6 and 1 <= risk_CH <= 6;

proc corr spearman data = sampleCH;
var risk_CH  prisk_CH;  run;

proc corr spearman data = final.gambles_p;
var risk risk_R;  run;

proc sort data = final.gambles_p; by id96 id96_R;
proc sort data = sampleCH; by id96 p_id96;

data psamples(keep = id96 p_id96  ER7012 risk risk_R match age_R black_R married_R dropout_R smcoll_R cograd_R pscoll_R male_R lninc_R);
	merge final.gambles_p(in=inKSS rename=id96_R = p_id96) sampleCH(in=inCH); 
by id96 p_id96;

if risk = risk_CH and risk_R = prisk_CH and inKSS and inCH then match = 1;
	else if inKSS = 1 and inCH = 0 then match = 2;
	else if inKSS = 0 and inCH = 1 then match = 3;

if risk = . then risk = risk_CH;
if risk_R = . then risk_R = prisk_CH;


proc freq; tables match; 

** Overlap KSS and CH;
proc corr spearman data = psamples;
var risk  risk_R;  where match = 1; run;

** Only in KSS;
proc corr spearman data = psamples;
var risk  risk_R;  where match = 2; run;

** Only in CH;
proc corr spearman data = psamples;
var risk  risk_R;  where match = 3; run;

** KSS Sample;
proc corr spearman data = psamples;
var risk  risk_R;  where match in(1,2); run;

** CH Sample;
proc corr spearman data = psamples;
var risk  risk_R;  where match in(1,3); run;


data CHsamples(keep = id96 p_id96 risk risk_R match);
	set psamples;

** Macro Exports to Excel **;
%macro outts(name);
proc dbload dbms=excel data=&name;
path="G:\res\Research\RiskPrefs\PSID_KSS\Analysis\&name..xls";
putnames yes;
limit=0;
load;
run;
%mend outts; 
%outts(CHsamples);
run;
